/*
  Lightwall Demo
*/
#include <lightwall.h>
#include <delay_x.h> // by Hans-Juergen Heinrichs


#define INTER_FRAME_GAP 500 // Default delay between frames, in mS


uint16_t ifg = INTER_FRAME_GAP;

LightWall LW;

void setup() 
{
  LW.begin(50,50);
}


//Test array, 1 bit color resolution, used for debug testing and demo() output.
//                        Don't forget to invert the data!
//               RGBPYTWB  GBPYTWBR  BPYTWBRG  PYTWBRGB  YTWBRGBP  TWBRGBPY  WBRGBPTY  BRGBPYTW
uint8_t rbits[] = {B01100101,B11001010,B10010101,B00101011,B01010110,B10101100,B01011001,B10110010}; 
uint8_t gbits[] = {B10110001,B01100011,B11000110,B10001101,B00011011,B00110110,B01101100,B11011000};   
uint8_t bbits[] = {B11001001,B10010011,B00100111,B01001110,B10011100,B00111001,B01110010,B11100100};  
int demoBytes=8; //length of the demo array


// When this is called, the bits array is loaded with the next data set from the demo array 
int demopos=0;
void next_test_data()
{
  for (int i=0;i<4;i++)
  {
    LW.Buffer[i]=bbits[demopos];
    LW.Buffer[i+4]=gbits[demopos];
    LW.Buffer[i+8]=rbits[demopos];
  }
  demopos++;
  if (demopos==demoBytes) demopos=0;
}


// Demo Routine plays 
void loop()
{
  for (int i=0;i<10;i++)
  { 
    next_test_data();
    for (int j=0;j<50;j++)
    {
      next_test_data();
      LW.send_frame(j);
      _delay_us(48);

    }
    _delay_us(100000);
  }
  LW.fadeout(3000);
  for (int i=0;i<50;i++)
  {
    LW.send_frame(i);
    _delay_us(48);
  }
  _delay_us(1000000);
  LW.fadein(3000);
  _delay_us(1000000);
}

