#include <stdio.h>
#include <termios.h>
#include "lights.h"

#define STRINGS 8
#define LIGHTS 50

void AcquireImage(int string, int light, int on) {
  char tmp[256];
  sprintf(tmp, "ssh 10.0.5.11 wget -O/home/hubbe/hack/teensy/chaosdisplay/software/images/light_%02d_%02d_%d.jpg http://10.0.5.43:8080/shot.jpg",
	  string, light, on);
  system(tmp);
}

int main(int argc, char **argv) {
  int strings = atoi(argv[1]);
  int lights = atoi(argv[2]);
  TeensyLightWallRelay relay("/dev/ttyACM0", strings);
  vector<LampColor> colors(strings);
  vector<LampColor> black(strings);
  relay.Init();
  sleep(5);
  for (int s = 0; s < strings; s++) {
    colors[s].intensity = 0x00;
    colors[s].color[0] = 0x00;
    colors[s].color[1] = 0x00;
    colors[s].color[2] = 0x00;
  }
  for (int s = 0; s < strings; s++) {
    for (int l = 0; l < lights; l++) {
      fprintf(stderr, "String = %d light = %d\n", s, l);
      relay.SetPixels(63, black);
      for (int c = 0; c <= 7; c++) {
	colors = black;
	colors[s].intensity = 0xCC;
	colors[s].color[0] = c & 1 ? 0xFF : 0;
	colors[s].color[1] = c & 2 ? 0xFF : 0;
	colors[s].color[2] = c & 4 ? 0xFF : 0;
	relay.SetPixels(l, colors);
	AcquireImage(s, l, c);
      }
    }
    relay.SetPixels(63, black);
  }
}
